//DayBack rich text editor v1.0

//Purpose:
//Allows you to modify an event property in a rich text editor

//Note:
//Requires the 'injectTinyMCE.js' app action in your group in order to load the editor

//Action Type: Button action

//More info on custom button actions here:
//https://docs.dayback.com/article/5-custom-actions


//Change this to the NAME OF the event field you'd like to edit with the rich text editor
var fieldToEdit = 'description';

//The title of the modal window
var modalTitle = 'Modify Event Description';

//The confirmation button text
var modalConfirmText = 'Save';

//The cancel button text
var modalCancelText = 'Cancel';


//----------- You shouldn’t need to edit below this line -------------------

//Show a modal to edit the description value
showInputModal(modalTitle, editEvent[fieldToEdit], null, modalConfirmText, function(result){
    editEvent[fieldToEdit] = result;
}, modalCancelText);

function showInputModal(title, inputValue, inputPlaceholder, confirmButtonText, confirmFunction, cancelButtonText, cancelFunction, warning, modalContainer) {
    var confirmButtonStyle = warning ? 'btn-danger dbk_button_danger' : 'btn-success dbk_button_success' ;
    var cancelButton = cancelButtonText ? '<button ng-click="popover.config.cancelFunction();" class="btn btn-xs btn-secondary">' + cancelButtonText + '</button>' : '';
    var confirmButton = confirmButtonText ? '<button ng-click="popover.config.confirmFunction();" class="btn btn-xs  ' + confirmButtonStyle + '">' + confirmButtonText + '</button>' : '';

    var template =
'<div style="background: rgba(0,0,0,0.75); color: white;"><div class="pad-large text-center">' +
        '<h4>' + title + '</h4>' +
        '<div class="pad">' +
            '<textarea class="form-control" id="inputModalInput" rows="8" placeholder="' + inputPlaceholder + '">' + inputValue + '</textarea>' +
        '</div>' +
        '<div class="pad">' + cancelButton + ' ' + confirmButton +
        '</div>' +
    '</div>' +
'</div>';

    var config = {
        container: modalContainer ? modalContainer : (document.querySelector('#calendar-container') ? '#calendar-container' : '#app-container'),
        type: 'modal', // modal or popover
        destroy: true,
        width: 600,
        height: 600,
        confirmFunction: runConfirmFunction,
        cancelFunction: runCancelFunction,
        onShow: injectTinyMCE,
        onShown: '',
        onHide: removeTinyMCE,
        onHidden: removeTinyMCE,
        show: true
    };

    var popover = utilities.popover(config, template);
    setTimeout(injectTinyMCE, 5);

    function runConfirmFunction() {
        if (confirmFunction) {
            confirmFunction(tinyMCE && tinyMCE.activeEditor ? tinyMCE.activeEditor.getContent({format: 'raw'}) : document.getElementById('inputModalInput').value);
        }
        config.show = false;
    }

    function runCancelFunction() {
        if (cancelFunction) {
            cancelFunction();
        }
        config.show = false;
    }

    function injectTinyMCE() {
        if (typeof (tinyMCE) !== 'undefined' && tinyMCE){
            tinyMCE.init({
                selector: '#inputModalInput',
                menubar: false,
            });
        }
        else{
            utilities.showModal('Error loading tinyMCE', 'tinyMCE is required to use this custom action. Please add the "injectTinyMCE" app action to your group', 'ok');
        }
    }

    function removeTinyMCE() {
        tinyMCE.remove('#inputModalInput');
    }
}